import java.util.Random;

public class GenAntiCubicSolutionWithNoise {

    final static int NOISE_COUNT = 50;

    public static void main(String[] args) {
        if (args.length < 3) {
            System.err.println("Usage: GenAntiCubicSolution segmentsCount maxThickness seed");
            return;
        }
        int n = Integer.parseInt(args[0]);
        int maxThickness = Integer.parseInt(args[1]);
        if (n <= NOISE_COUNT)
            throw new AssertionError(String.format("n must be at least %d", NOISE_COUNT + 1));
        int k = 2 * n - NOISE_COUNT + 1;
        System.out.println(n + " " + k);
        Random random = new Random(Integer.parseInt(args[2]));
        for (int i = 0; i < n - NOISE_COUNT; i++)
            System.out.println(1 + " " + (i + n) + " " + (random.nextInt(maxThickness) + 1));
        for (int i = 0; i < NOISE_COUNT; i++) {
            int left = random.nextInt(k) + 1;
            int thickness = random.nextInt(maxThickness) + 1;
            System.out.println(left + " " + left + " " + thickness);
        }
    }
}
