import java.util.Random;

public class GenRandom {

    public static void main(String[] args) {
        if (args.length != 4)
            throw new RuntimeException("usage: GenRandom segmentCount k maxThickness seed");
        int count = Integer.parseInt(args[0]);
        int k = Integer.parseInt(args[1]);
        int maxHeight = Integer.parseInt(args[2]);
        int seed = Integer.parseInt(args[3]);
        Random random = new Random(seed);
        if (k < 6)
            k = 6;
        System.out.println(count + " " + k);
        int smallH = Math.max(maxHeight - 1, 1);
        int largeH = maxHeight;
        for (int i = 0; i < Math.min(3, count); i++)
            System.out.println((i + 1) + " " + (i + 3) + " " + (i % 2 == 0 ? largeH : smallH));
        if (count >= 4)
            System.out.println(6 + " " + k + " " + smallH);
        int low = -2;
        int high = k + 2;
        for (int i = 0; i < count - 4; i++) {
            int left = random.nextInt(high - low + 1) - 2;
            int right = random.nextInt(high - low + 1) - 2;
            int height = random.nextInt(maxHeight) + 1;
            if (left == right)
                left++;
            if (left > right) {
                int temp = left;
                left = right;
                right = temp;
            }
            left++;
            right++;
            int l = left + 5;
            int r = right;
            l = Math.max(l, 6);
            l = Math.min(l, k);
            r = Math.max(l, 6);
            r = Math.min(r, k);
            if (l > r) {
                int t = l;
                l = r;
                r = t;
            }
            System.out.println(l + " " + r + " " + height);
        }
    }
}
