#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 3000;

struct seg {
  int l, r, p;
};

int dp[MAXN][MAXN];
seg v[MAXN];

int cost(int a, int b) {
  if (v[a].r == v[b].l) return max(v[a].p, v[b].p);
  return v[a].p + v[b].p;
}

vector<int> ids[MAXN];
const int INF = 2000100000;

int main() {
  int n, k;
  scanf("%d%d", &n, &k);
  for (int i = 0; i < n; i++) {
    scanf("%d%d%d", &v[i].l, &v[i].r, &v[i].p);
    v[i].r++;
  }
  k++;
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < n; j++) {
      dp[i][j] = INF;
    }
  }
  sort(v, v + n, [](const seg& a, const seg& b) {
        if (a.r != b.r) {
          return a.r < b.r;
        }
        if (a.l != b.l) {
          return a.l < b.l;
        }
        return a.p < b.p;
      });

  int ptr = 0;
  for (int i = 0; i < n; i++) {
    if (ptr == 0 || v[i].l != v[ptr - 1].l || v[i].r != v[ptr - 1].r) {
      v[ptr++] = v[i];
    }
  }
  n = ptr;

  int ans = INF;

  for (int i = 0; i < n; i++) {
    if (v[i].l == 1 && v[i].r == k) {
      ans = min(ans, v[i].p);
    }
    for (int j = i + 1; j < n; j++) {
      if (v[i].l == 1 && v[j].l <= v[i].r) {
        dp[i][j] = cost(i, j);
        ids[i].push_back(j);
        if (v[j].r == k) {
          ans = min(ans, cost(i, j));
        }
      }
    }
  }


  for (int a = 0; a < n; a++) {
    for (int b : ids[a]) {
      //printf("%d, %d : (%d, %d), (%d, %d) -> %d\n", a, b, v[a].l, v[a].r, v[b].l, v[b].r, dp[a][b]);
      for (int c = b + 1; c < n; c++) {
        //printf("goto c; (%d, %d), %d %d\n", v[c].l, v[c].r, v[c].l <= v[b].r, v[c].l >= v[a].r);
        if (v[c].l <= v[b].r && v[c].l >= v[a].r) {
          if (dp[b][c] == INF) { 
            ids[b].push_back(c);
          }
          int cur = max(dp[a][b], cost(b, c));
          dp[b][c] = min(dp[b][c], cur); 
          if (v[c].r == k) {
            //printf("c = %d, (%d, %d) cur = %d\n", c, v[c].l, v[c].r, cur);
            ans = min(ans, cur);
          }
        }
      }
    }
  }
  if (ans == INF) {
    printf("-1\n");
  } else {
    printf("%d\n", ans);
  }
  return 0;
}
