#include <cstdio>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std;

const int MAXN = 100000;

const int P = 1 << 25;
const int INF = 2000100000;

typedef long long ll;

ll A[P];
int V[P];

int tot_cnt = 0;

int get_id(int a, int b) {
  int h = (a * 239017 + b) & (P - 1);
  ll x = (ll(a) << 32) | b;
  while (true) {
    if (A[h] == x) return h;
    if (A[h] == 0) {
      A[h] = x;
      V[h] = INF;
      tot_cnt++;
      assert(tot_cnt <= P / 2);
      return h;
    }
    h = h + 1;
    if (h == P) h = 0;
  }
}

struct seg {
  int l, r, p;
};

seg v[MAXN];

int cost(int a, int b) {
  if (v[a].r == v[b].l) return max(v[a].p, v[b].p);
  return v[a].p + v[b].p;
}

vector<int> ids[MAXN];

int main() {
  int n, k;
  scanf("%d%d", &n, &k);
  for (int i = 0; i < n; i++) {
    scanf("%d%d%d", &v[i].l, &v[i].r, &v[i].p);
    v[i].r++;
  }
  k++;
  sort(v, v + n, [](const seg& a, const seg& b) {
        if (a.r != b.r) {
          return a.r < b.r;
        }
        if (a.l != b.l) {
          return a.l < b.l;
        }
        return a.p < b.p;
      });

  int ptr = 0;
  for (int i = 0; i < n; i++) {
    if (ptr == 0 || v[i].l != v[ptr - 1].l || v[i].r != v[ptr - 1].r) {
      v[ptr++] = v[i];
    }
  }
  n = ptr;

  int ans = INF;

  for (int i = 0; i < n; i++) {
    if (v[i].l == 1 && v[i].r == k) {
      ans = min(ans, v[i].p);
    }
    for (int j = i + 1; j < n; j++) {
      if (v[i].l == 1 && v[j].l <= v[i].r) {
        int H = get_id(i, j);
        V[H] = cost(i, j);
        ids[i].push_back(j);
        if (v[j].r == k) {
          ans = min(ans, cost(i, j));
        }
      }
    }
  }


  for (int a = 0; a < n; a++) {
    for (int b : ids[a]) {
      //printf("%d, %d : (%d, %d), (%d, %d) -> %d\n", a, b, v[a].l, v[a].r, v[b].l, v[b].r, dp[a][b]);
      for (int c = b + 1; c < n; c++) {
        //printf("goto c; (%d, %d), %d %d\n", v[c].l, v[c].r, v[c].l <= v[b].r, v[c].l >= v[a].r);
        if (v[c].l <= v[b].r && v[c].l >= v[a].r) {
          int HA = get_id(a, b);
          int HC = get_id(b, c);
          if (V[HC] == INF) { 
            ids[b].push_back(c);
          }
          int cur = max(V[HA], cost(b, c));
          V[HC] = min(V[HC], cur); 
          if (v[c].r == k) {
            //printf("c = %d, (%d, %d) cur = %d\n", c, v[c].l, v[c].r, cur);
            ans = min(ans, cur);
          }
        }
      }
    }
  }
  if (ans == INF) {
    printf("-1\n");
  } else {
    printf("%d\n", ans);
  }
  return 0;
}
